'use strict';

var pe = require('case-anything');
var creator = require('@terminal-nerds/snippets-regexp/creator');
var snippetsType = require('@terminal-nerds/snippets-type');
var zod = require('zod');
var primitive = require('@terminal-nerds/snippets-type/primitive');

function _interopNamespace(e) {
	if (e && e.__esModule) return e;
	var n = Object.create(null);
	if (e) {
		Object.keys(e).forEach(function (k) {
			if (k !== 'default') {
				var d = Object.getOwnPropertyDescriptor(e, k);
				Object.defineProperty(n, k, d.get ? d : {
					enumerable: true,
					get: function () { return e[k]; }
				});
			}
		});
	}
	n.default = e;
	return Object.freeze(n);
}

var pe__namespace = /*#__PURE__*/_interopNamespace(pe);

var E=Object.defineProperty;var j=Object.getOwnPropertyDescriptor;var J=Object.getOwnPropertyNames;var z=Object.prototype.hasOwnProperty;var B=(e,t)=>{for(var r in t)E(e,r,{get:t[r],enumerable:!0});},_=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let i of J(t))!z.call(e,i)&&i!==r&&E(e,i,{get:()=>t[i],enumerable:!(n=j(t,i))||n.enumerable});return e},a=(e,t,r)=>(_(e,t,"default"),r&&_(r,t,"default"));var p={};B(p,{CHARS:()=>l,CHARS_SCHEMAS:()=>M,CHAR_SCHEMA:()=>f,CHAR_TYPES:()=>g,CHAR_TYPE_SCHEMA:()=>h,EMPTY_STRING_SCHEMA:()=>H,LATIN_CHARS:()=>m,LATIN_CHAR_SCHEMA:()=>P,LOWER_CASED_LATIN_CHARS:()=>C,NON_LATIN_CHARS:()=>V,NON_NUMBER_CHARS:()=>q,NON_SPECIAL_CHARS:()=>Q,NUMBER_CHARS:()=>c,NUMBER_CHAR_SCHEMA:()=>I,SINGLE_CHARS:()=>F,SPECIAL_CHARS:()=>x,SPECIAL_CHAR_SCHEMA:()=>O,UPPER_CASED_LATIN_CHARS:()=>L,getCharType:()=>ee,getChars:()=>se,getJoinedChars:()=>d,hasChars:()=>re,isChar:()=>te,isNumeric:()=>ae,isPalindrome:()=>ne,isSingleChar:()=>X,isString:()=>K,isStringEmpty:()=>W,isValidCharType:()=>Z,reverseString:()=>k,validateCharType:()=>S,validateSingleChar:()=>y,validateString:()=>o});var s={};a(s,pe__namespace);a(p,s);function o(e){return primitive.validatePrimitive(e,"string")}function K(e){return primitive.isPrimitive(e,"string")}var H=zod.z.literal("");function W(e){return o(e),H.safeParse(e).success}var g=["latin","number","special"],C=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","r","s","t","u","v","w","x","y","z"],L=C.map(e=>e.toUpperCase()),m=[...C,...L],c=["0","1","2","3","4","5","6","7","8","9"],x=["~","`","@","#","$","%","^","&","*","(",")","-","_","+","=","\\","|","]","}","[","{",'"',"'",";",":","/","?",".",">",",","<"],F=[...C,...c,...x],l={latin:C,number:c,special:x},V=[...c,...x],q=[...m,...x],Q=[...m,...c],f=snippetsType.STRING_SCHEMA.length(1,"This is supposed to be a single char"),h=zod.z.enum(g),P=zod.z.enum(C),I=zod.z.enum(c),O=zod.z.enum(x),M={latin:P,number:I,special:O};function y(e){f.parse(e);}function X(e){return o(e),f.safeParse(e).success}function d(e){return e.join("")}function S(e){h.parse(e);}function Z(e){return o(e),h.safeParse(e).success}function ee(e,t={}){y(e);let{caseInsensitive:r=!0}=t;for(let n of g)if(new Set(l[n]).has(r?e.toLowerCase():e))return n;throw new TypeError(`Unrecognized char type for: "${e}"`)}function te(e,t){let{type:r,caseInsensitive:n=!0}=t;return y(e),S(r),M[r].safeParse(r==="latin"&&n?e.toLowerCase():e).success}function re(e,t){let{type:r,...n}=t;o(e),S(r);let i=d(l[r]);return creator.createRegExp(creator.charIn(i),creator.setRegExpFlags({caseInsensitive:!0,...n})).test(e)}function se(e,t){let{type:r,...n}=t;o(e),S(r);let i=d(l[r]),A=creator.createRegExp(creator.charIn(i),creator.setRegExpFlags({caseInsensitive:!0,global:!0,multiline:!0,...n})),w=e.matchAll(A),R=[];for(let U of w)R.push(U.at(0));return R}function k(e){return o(e),[...e].reverse().join("")}function ne(e){return k(e)===e}function ae(e){return o(e),Number.isNaN(Number(e))===!1}

exports.CHARS = l;
exports.CHARS_SCHEMAS = M;
exports.CHAR_SCHEMA = f;
exports.CHAR_TYPES = g;
exports.CHAR_TYPE_SCHEMA = h;
exports.EMPTY_STRING_SCHEMA = H;
exports.LATIN_CHARS = m;
exports.LATIN_CHAR_SCHEMA = P;
exports.LOWER_CASED_LATIN_CHARS = C;
exports.NON_LATIN_CHARS = V;
exports.NON_NUMBER_CHARS = q;
exports.NON_SPECIAL_CHARS = Q;
exports.NUMBER_CHARS = c;
exports.NUMBER_CHAR_SCHEMA = I;
exports.SINGLE_CHARS = F;
exports.SPECIAL_CHARS = x;
exports.SPECIAL_CHAR_SCHEMA = O;
exports.UPPER_CASED_LATIN_CHARS = L;
exports.getCharType = ee;
exports.getChars = se;
exports.getJoinedChars = d;
exports.hasChars = re;
exports.isChar = te;
exports.isNumeric = ae;
exports.isPalindrome = ne;
exports.isSingleChar = X;
exports.isString = K;
exports.isStringEmpty = W;
exports.isValidCharType = Z;
exports.reverseString = k;
exports.validateCharType = S;
exports.validateSingleChar = y;
exports.validateString = o;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=main.cjs.map