import { Join, Split } from 'type-fest';

type ReversedTuple<T> = T extends [infer Head, ...infer Rest] ? [...ReversedTuple<Rest>, Head] : [];
type ReversedString<T extends string> = Join<ReversedTuple<Split<T, "">>, "">;
declare function reverseString<T extends string>(input: T): ReversedString<T>;
/** @see {@link https://en.wikipedia.org/wiki/Palindrome} Palindrome */
declare function isPalindrome(input: string): boolean;
declare function isNumeric(input: string): boolean;

export { ReversedString, ReversedTuple, isNumeric, isPalindrome, reverseString };
